const list_type_bool_keys = ['proxy_intercept_error', 'ssl_stapling', 'backup', 'down', 'ssl']
const list_type_list_keys = [
    'ssl_ciphers', 'ssl_protocols', 'dns', 'index', 'set_real_ip_from', 'upstream', 'location', 'proxy_set_header',
    'set_real_ip_from'
]
const list_type_int_keys = [
    'fail_timeout', 'max_fails', 'weight', 'client_buffer_body_size', 'client_max_body_size', 'client_body_timeout',
    'listen_port', 'ssl_timeout', 'ssl_session_cache_size', 'proxy_connect_timeout', 'proxy_send_timeout',
    'proxy_read_timeout', 'port', 'size'
]
const list_type_float_keys = ['proxy_http_version',]
const list_type_dynamic_keys = ['servers',]


function showModalSettingsNginx(name_param, key) {
    let modal = $('#edit_setting_nginx');
    let settings_name_input = $('#edit_setting_nginx #setting_name');
    let key_input = $('#edit_setting_nginx #key_id');
    let input_settings = $(`#nginx_${name_param}_input_${key}`);
    let span_settings = $(`#nginx_${name_param}_text_${key}`);
    let common_input = $(`#common_input_settings`);

    key_input.val(key);
    settings_name_input.val(name_param);

    common_input.val(input_settings.val());
    window.current_table = 'nginx';
    modal.modal('show');
}


function save_settings() {
    let modal = $('#edit_setting_nginx');
    let settings_name = $('#edit_setting_nginx #setting_name').val();
    let key_id = $('#edit_setting_nginx #key_id').val();
    let input_settings = $(`#nginx_${settings_name}_input_${key_id}`);
    let span_settings = $(`#nginx_${settings_name}_text_${key_id}`);
    let common_input = $(`#common_input_settings`);
    const current_table = window.current_table;
    const csrftoken = document.querySelector('input[name=csrfmiddlewaretoken]').value;

    let data = {};
    data[settings_name] = common_input.val();

    let home = document.getElementById('home').title;
    let url = home + '/nginx/post/set/';

    $.ajax({
        url: url,
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        data: {
            key: key_id,
            data: JSON.stringify(data),
            table: current_table,
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            let data = response;
            if (data.status === 'success') {
                input_settings.val(common_input.val());
                span_settings.text(common_input.val());
                if (settings_name.includes('size')) {
                    $(input_settings[0].parentElement.querySelector('.type-size')).css({'display': 'unset'});
                }
            } else if (data.status === 'error') {
                $('#error_edit_setting').css({'display': 'block'});
            }
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });


    modal.modal('hide');
}